package com.iformall.controller.mem;

import com.iformall.annotation.SystemControllerLog;
import com.iformall.controller.base.BaseController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.WxCUser;
import com.iformall.service.WxCUserService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("wxCUser")
public class WxCUserController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxCUserService wxCUserService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "用户管理-列表")
    public ResultData list(@ModelAttribute WxCUser wxCUser, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxCUserController::list");
        if (null == wxCUser) wxCUser = new WxCUser();
        final PageInfo<WxCUser> page = wxCUserService.listAsPage(wxCUser, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "用户管理-新增")
    public ResultData add(@RequestBody WxCUser wxCUser) {
        logger.debug("[" + getIpAddr() + "] WxCUserController::add");
        //Assert.notNull(wxCUser.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxCUserService.saveOrUpdate(wxCUser);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "用户管理-更新")
    public ResultData update(@RequestBody WxCUser wxCUser) {
        logger.debug("[" + getIpAddr() + "] WxCUserController::update");
        wxCUserService.saveOrUpdate(wxCUser);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "用户管理-删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCUserController::delete");
        wxCUserService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "用户管理-查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxCUserController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxCUserService.getById(id));
    }


}
